/* embedded_coral.S : simple embedded coral commands used by o2r.C, r2o.C
   
   programmed by Celena Tanguay & Michael Siff 
   Spring 1995
   for cs784
   (for more detailed description see document rodin-opossum-interface.tex)
 */


/* coral++ include files */
/* --------------------- */
#include "CoralIncludes.h"



/* *** Note: The truly embedded version below is commented out because for
whatever reason it currently fails to wokr properly with the either o2r.C
or r2o.C 
For the time being the "hacked C++ version suffices, although it has
problems reading in .T files, thus .F files may be required.
*/


//consults the file specified 
  void embedded_coral_consult(char *filename)
   {
     \[
   	consult(($string)$filename).
     \]
   }

  void make_sets() {

     \[
        set(insert_mode).     % Probably not required

        my( hello, { 3,4,5,6,7 }, { a,b,c,d,e } ).
        my( goodbye, { 2,4,0,1,7 }, { c,m,p,q,r } ).

        yours( peas, { peas, {in, {pods}}}, 0 ).
        yours( beans, 4, { {}, {mt}, {} }  ).
     \]
  }

//void embedded_coral_consult(char *filename)
//{
//  static char str[50];
//  int save_exec_mode = (int) corexEnv->C_exec_mode;
//
//  corexEnv->C_exec_mode = COR_DOING_INTERPRET;
//
//  if (corconsultFile(filename,filename)){
//    corparseStack->parse(stderr,0);
//  } 
//  else {
//    fprintf(stderr, "Consult of %s failed", filename);
//    exit(1);
//  }
//  corexEnv->C_exec_mode = save_exec_mode;
//} 


int main(int argc, char **argv) {

    char *file = "data.F";

    init_coral(argv[0]);

    embedded_coral_consult(file);
    
    \[
        clear(interactive_mode).     % I despise interactive_mode!
        ?data(X,Y).
    \]

    // Try writing tables containing sets
    make_sets();

    \[
        % Now write out the sets
        write_table(my(_,_,_), "sets.T").
        write_table(yours(_,_,_), "sets.T").
    \]

    exit_coral();

    return(0); 
}	

