
/*
 * Example of the use of the predicates is_list, etc.
 */

#include <iostream.h>

int main(int argc, char **argv)
{
    cout << "pred1.S: Demonstrating predicates, ie: the is_<type> functions.\n";

    init_coral(argv[0]);
  
    \[
      clear(interactive_mode).
    \]

    // Some mixed data for use to figure out (in lists
    // so we can demonstarte pulling them apart later)
    \[
      mixed([0, one, nil, {}, 3.14]).
      mixed([5.0, X, _, [one, two, three] ]).
      mixed(["X", {4, foo, 2.5}, [] ]).
      mixed([ cons(2,[]), 7.7]).
      mixed([ func(arg1, 2, Arg3), [[[]]] ]).
    \]

      // Scan the whole relation
    Cor_ScanDesc *scan = open_scan("mixed(_).");

    ASSERT(scan);

    Cor_Tuple *tuple;

      // Iterate over the tuples in the relation
    for (tuple = scan->next_tuple(); !(scan->no_match());
                     tuple = scan->next_tuple()) {

          // Print them out as tuples 
        cout << "mixed(" << *tuple << ").\n";
    }

    exit_coral();

    return(0);
}

