clear(interactive_mode).

print("open1\n").
rdb_open_db(syb1, sybase, beyer, beyer, pw).
print("open2\n").
rdb_open_db(syb2, sybase, beyer2, beyer, pw).

% not really supposed to be able to issue selects from here, but it works
% for sybase...
print("execute1\n").
rdb_execute(syb1, "select count(*) from sysobjects").
print("execute2\n").
rdb_execute(syb2, "select count(*) from sysobjects").

print("map1\n").
rdb_map(syb1, obj1(sysobjects(name, type, id))).
print("map2\n").
rdb_map(syb1, col1(syscolumns(id, number, name, type, offset))).

print("query1\n").
?obj1(N,"S",I).
print("query2\n").
?col1(1,N,Nm,T,O).
print("query3\n").
?obj1(TName,TType,I),col1(I,CNum, CName, CType, COffset).
print("join1\n").
rdb_join(join(obj1(_,_,I),col1(I))).
print("query4\n").
?join(TName,TType,TI,CI,CNum, CName, CType, COffset).

print("map3\n").
rdb_map(syb2, obj2(sysobjects(name, type, crdate))).
print("query5\n").
?obj2(N,T,C).
print("query6\n").
?obj1(N,T1),obj2(N,T2,C2).


% loon's sybase is not accessible outside of loon
% rdb_open_db(syb3, sybase, beyer, beyer, pw, "LOON").
rdb_open_db(syb3, sybase, beyer, beyer, pw, "LOON").
rdb_map(syb3, obj3(sysobjects(name, type, id))).
?obj3(N,"S",I1).
?obj3(N,"S",I1),obj2(N,T2,I2),obj1(N,T1,I1).

print("attempting to check uniqueness...\n").
module countrels.
@no_preprocessing +.
% @pipelining +.
export s1[f], s2[f], s3[f].
s1(count(<N>)) :- obj1(N).
s2(count(<N>)) :- obj2(N).
s3(count(<N>)) :- obj3(N).
end_module.
?s1(Count).
?s2(Count).
?s3(Count).


% transactions are not currently supported by sybase...
% rdb_commit().
% rdb_rollback().
