// *************************************************************************
//    Globals.C
// *************************************************************************

#include "Globals.h"

#include "Trail.h"
#include "ConnectArray.h"

// *************************************************************************

Cor_Trail        *Cor_CurTrail     = NULL;

Cor_ExecutionEnv *Cor_deflt_exEnv  = NULL;
Cor_ExecutionEnv *Cor_exEnv        = NULL;

Cor_ParserStruct *Cor_parserStruct = NULL;

CoralConfig      *coralConfig      = NULL;

Cor_TableStack   *Cor_T_Stack      = NULL;


   // Pointer to the current ParseStack
Cor_ParseStack   *Cor_parseStack = NULL;

   // Pointer to the top ParserEnv of the current ParseStack
Cor_ParserEnv    *Cor_parseEnv   = NULL;        

   // The current user, automagically kept up to date
Cor_User         *Cor_curUser    = NULL;

   // The current connection, automagically kept up to date
Cor_Connection   *Cor_curConn    = NULL;

   // The connection array should only be addressed through the pointer
   // (where possible), this gives us the option of adding more someday.
Cor_ConnectArray *Cor_clients    = NULL; 

class  Cor_DatabaseStruct;
class  Cor_SymTable;

Cor_DatabaseStruct *Cor_BuiltinDB     = NULL;
Cor_DatabaseStruct *Cor_CurDB         = NULL;
Cor_SymTable       *Cor_DatabaseTable = NULL;

class  Cor_break_info;
Cor_break_info     *Cor_brk_Info      = NULL;

class Cor_Entity_Array;
Cor_Entity_Array   *Coral_Free        = NULL;

class Cor_BindEnv;
Cor_BindEnv        *Cor_UnusedEnv     = NULL;

class Cor_suspensionClass;
Cor_suspensionClass *Cor_suspension   = NULL;

class Cor_Term;
Cor_Term *Cor_static_terms            = NULL;
Cor_Term *Cor_usable_terms            = NULL;

class Cor_StrRefTable;
Cor_StrRefTable *Cor_string_ref_table = NULL;

class Cor_Relation;
Cor_Relation    *Cor_HelpRel          = NULL;

// *************************************************************************

char coral_pid[32];        // Process Id of this coral program

CoralStream *cin_strm  = NULL;
CoralStream *cout_strm = NULL;
CoralStream *cerr_strm = NULL;

// *************************************************************************
