// *************************************************************************
//    CoralBreak.C
// *************************************************************************

#include <stdio.h>

#include "Globals.h"
#include "CoralBreak.h"
#include "Relation.h"
#include "Debug.h"

// *************************************************************************

int Cor_opt;

char *Cor_Scc_String = "Scc";
char *Cor_Iteration_String = "Iteration";
char *Cor_Rule_String = "Rule";

/*****************************************************************************/

static int b_flag = 0;

/*****************************************************************************/
void coral_break(char *s, int id )
{
#ifdef    DO_CALL_STACK
    CallStk_Mark    callstk_mark(__FUNCTION__,__FILE__,__LINE__);
#endif
    char str[256];
    char _Str[256];

    str[0] = '\0';
    if (id < 0)
        *(Cor_exEnv->out_strm)
                << "\nSetting up break points for module " << s;
    else
        *(Cor_exEnv->out_strm)
                << "\nSetting up break points for " << s << " " << id;

    if (Cor_opt) {
        if (b_flag){
            // Send special string across
            *(Cor_exEnv->explain_strm) << "explain_break(1,0).\n" << flush;
        }
        b_flag = 1;
    }

    *(Cor_exEnv->out_strm) << "\nContinue running program? (y or n) ";
    Cor_exEnv->in_strm->scanf("%s", str);
    while (str[0] != 'y') {
        *(Cor_exEnv->out_strm) << "\nContinue running program? (y or n) ";
        Cor_exEnv->in_strm->scanf("%s", str);
    }

    sprintf(_Str,"def_new_%s(X,Y)",Cor_my_str);
 
    if (Cor_opt) {
        // clear the new relation
        *(Cor_exEnv->explain_strm) << "rel_clear(" << _Str << ").\n" << flush;
    }

    *(Cor_exEnv->out_strm) << endl;
}

// *************************************************************************
