//********************************************
// NLExtJoin.h
//
// Ravi Murthy
//*********************************************

#ifdef    WITH_PERSISTENCE
#ifndef _NLExtJoin_H_
#define _NLExtJoin_H_

#include "ExtJoin.h"

//***************************************************

// This class implements the nested loops join on external relations.

class Cor_NLExtJoin : public Cor_ExtJoin {
  public:
    Cor_NLExtJoin(Cor_TupleIterator* left, Cor_TupleIterator *right);
    Cor_NLExtJoin(Cor_ExtJoin* left, Cor_TupleIterator *right);
    virtual ~Cor_NLExtJoin();

    virtual Cor_Tuple *get_next_tuple(Cor_TupleIterator& it);

  private:
    int reset_second;
};

// *************************************************************************
#endif
#endif // WITH_PERSISTENCE
