// *************************************************************************
//    DBSolvers.h
// *************************************************************************

#ifndef    _DBSolvers_H_
#define    _DBSolvers_H_

//#include "Globals.h"
#include "BuiltinRelation.h"
//#include "BuiltinSymbols.h"
//#include "CoralError.h"
//#include "Util.h"
#include "Database.h"
#include "TupleIterator.h"
//#include "ClientProtocol.h"
//#include "CArg.h"

// *************************************************************************

    // For parsing from strings
#define BUFF_MAX 5000

// *************************************************************************

Cor_BindEnv *Cor_CreateDBSolver(Cor_BuiltinRelation&,
        Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_DestroyDBSolver(Cor_BuiltinRelation&,
            Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_CurrentDBSolver(Cor_BuiltinRelation&,
        Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_ListDBSolver(Cor_BuiltinRelation&,
        Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_SaveDBSolver(Cor_BuiltinRelation&,
        Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_RenameDBSolver(Cor_BuiltinRelation&,
        Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_OpenRelSolver(Cor_BuiltinRelation&,
        Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_RelDisplay(Cor_BuiltinRelation&,
        Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_CloseRelSolver(Cor_BuiltinRelation&,
        Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_ClearRelSolver(Cor_BuiltinRelation&,
        Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_CopyRelSolver(Cor_BuiltinRelation&,
        Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_AddRelSolver(Cor_BuiltinRelation&,
        Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_RenameRelSolver(Cor_BuiltinRelation&,
        Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_ListAllSolver(Cor_BuiltinRelation&,
    Cor_TupleIterator& iterator);

Cor_BindEnv *Cor_ClearDBSolver(Cor_BuiltinRelation&,
        Cor_TupleIterator& iterator);

// *************************************************************************

#endif    _DBSolvers_H_
