// *************************************************************************
//	SipGen.h
// *************************************************************************

#ifndef _SipGen_H_
#define _SipGen_H_

#include "ClauseInfo.h"

#include "CArg.h"
#include "Rule.h"

// *************************************************************************

void create_sips();

int setup_arg(Cor_CArg *arg, void *data);
void setup_vars(Cor_Clause *rule, ClauseInfo *rule_info);

void cleanup_vars(ClauseInfo *rule_info);

void gen_sip_rule(ClauseInfo *rule_info, Cor_BitVector& adorn);

// *************************************************************************

#endif _SipGen_H_
