// *************************************************************************
//    Stack.C
// *************************************************************************

#include <stdlib.h>
#include <string.h>

#include "Stack.h"

        // The stack can grow, but start at a reasonable size
#define    DEFAULT_SIZE    8

// *************************************************************************
int  StringStack::push(char *x)
{
    int   len;
    char *item;

      // Duplicate the pushed item
    len = strlen(x);
    item = new char[len+1];
    strcpy(item,x);

    if (length >= data_size) {

        if (data_size == 0) {
            data_size = DEFAULT_SIZE;
            data = new char* [data_size];
        } else {

            int len = data_size;
            data_size += data_size;
            char **tmp_data = data;
            data = new char* [data_size];
            memcpy(data, tmp_data, len * sizeof(char*));
            delete [] tmp_data;
        }
    }

    data[length++] = item;

    return(length-1);
}

// *************************************************************************
